package com.izenpe.zain.cliente.cades;

import org.apache.axis.encoding.Base64;

import com.izenpe.zain.client.ZainConfig;
import com.izenpe.zain.cliente.util.Constantes;
import com.izenpe.zain.cliente.util.Propiedades;
import com.izenpe.zain.cliente.util.ZainUtil;
import com.safelayer.trustedx.client.smartwrapper.Constants;
import com.safelayer.trustedx.client.smartwrapper.SmartVerifyRequest;
import com.safelayer.trustedx.client.smartwrapper.SmartVerifyResponse;

public class ActualizacionFirmaCades_ES_T_Attached_A {
	// Nombre del fichero cuya firma va a ser actualizada.
	private static final String fileName = "HelloWorld.txt_Attached.p7s";

	public static void main(String[] args) {
		try {
			// Asignación de la configuración de forma programática
			ZainConfig.setCurrent(Propiedades.ZAIN_CONFIG);

			/*
			 * Se crea la petición a través de la URL definida en ZAIN_ENDPOINT.
			 */
			SmartVerifyRequest smartVerifyReq = new SmartVerifyRequest(Propiedades.ZAIN_ENDPOINT,
					SmartVerifyRequest.Service.DR);

			// Se establece el perfil No Repudio en la petición de Actualización
			// de firma.
			smartVerifyReq.setProfile(Constants.Profile.NONREP);
			
						/*
			 * Se establece el idioma de la petición en español. 2
			 * posibilidades: 1. Español: 'es' 2. Inglés: 'en'
			 */
			smartVerifyReq.setLanguage("es");

			/*
			 * Se solicita en la petición de Actualización que se añadan a la
			 * respuesta los valores de los certificados.
			 */
			smartVerifyReq.setAddCertificateValues(Constants.AddValues.SIMPLE);

			/*
			 * Se solicita en la petición de Actualización que se añadan a la
			 * respuesta la información de revocación de los certificados.
			 */
			smartVerifyReq.setAddRevocationValues(Constants.AddValues.SIMPLE);

			/*
			 * Se solicita en la petición de Actualización que se añadan los
			 * valores del Sello de Tiempo.
			 */
			smartVerifyReq.setAddTimeStampValues(Constants.AddValues.SIMPLE);

			/*
			 * True para que la respuesta incluya el formato de la firma (e.g.
			 * BES, ES-T). La invocación de método es indispensable para
			 * consultar el formato de la respuesta con getSignatureForm.
			 */
			smartVerifyReq.setAddSignatureForm(true);

			/*
			 * Con el valor Constants.SignatureFormat.ES_A, la respuesta
			 * añadiría información sobre la validez del certificado.
			 */
			smartVerifyReq.setReturnUpdatedSignature(Constants.SignatureFormat.ES_A);

			// Datos a verificar.
			smartVerifyReq.setSignatureBase64(Base64.encode(ZainUtil.readBinaryFile("data/output/" + fileName)));

			// Envío de la petición.
			SmartVerifyResponse smartVerifyResp = smartVerifyReq.send();

			// Se comprueba la validez de la respuesta de Actualización de firma
			// PKCS#7.
			if (Constantes.RMAJOR_SUCCESS.equals((smartVerifyResp.getResultMajor()))
					&& Constantes.RMINOR_SUCCESS.equals(smartVerifyResp.getResultMinor())) {
				String signBase64 = smartVerifyResp.getSignatureBase64();
				byte[] data = Base64.decode(signBase64);
				String destFilename = "data/output/" + "HelloWorld-ESA_Attached.txt.p7s";
				ZainUtil.writeBinaryFile(destFilename, data);
				System.out.println("La firma ha sido actualizada con éxito.");
			} else {
				System.out.println("La actualización de la firma contiene errores: "
						+ smartVerifyResp.getResultMessage());
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}